diff -ruN vdr-1.3.24/menu.c vdr-1.3.25/menu.c
--- vdr-1.3.24/menu.c	2005-03-20 16:14:51.000000000 +0100
+++ vdr-1.3.25/menu.c	2005-05-16 15:59:03.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.c 1.348 2005/03/20 15:14:51 kls Exp $
+ * $Id: menu.c 1.349 2005/05/16 13:59:03 kls Exp $
  */
 
 #include "menu.h"
@@ -872,7 +872,6 @@
   cTimer *ti = CurrentTimer();
   if (ti && !isempty(ti->Summary()))
      return AddSubMenu(new cMenuText(tr("Summary"), ti->Summary()));
-     //XXX cSkin::SetRecording()???
   return Edit(); // convenience for people not using the Summary feature ;-)
 }
 
@@ -1297,8 +1296,12 @@
 
   if (state == osUnknown) {
      switch (Key) {
-       case kOk:  return Execute();
-       default:   break;
+       case kRed:
+       case kGreen:
+       case kYellow:
+       case kBlue:   return osContinue;
+       case kOk:     return Execute();
+       default:      break;
        }
      }
   return state;
@@ -1430,6 +1433,63 @@
   return NULL;
 }
 
+// --- cMenuRecording --------------------------------------------------------
+
+class cMenuRecording : public cOsdMenu {
+private:
+  const cRecording *recording;
+public:
+  cMenuRecording(const cRecording *Recording);
+  virtual void Display(void);
+  virtual eOSState ProcessKey(eKeys Key);
+};
+
+cMenuRecording::cMenuRecording(const cRecording *Recording)
+:cOsdMenu(tr("Recording"))
+{
+  recording = Recording;
+  if (recording)
+     SetHelp(tr("Play"), tr("Rewind"));
+}
+
+void cMenuRecording::Display(void)
+{
+  cOsdMenu::Display();
+  DisplayMenu()->SetRecording(recording);
+  cStatus::MsgOsdTextItem(recording->Info()->Description());
+}
+
+eOSState cMenuRecording::ProcessKey(eKeys Key)
+{
+  switch (Key) {
+    case kUp|k_Repeat:
+    case kUp:
+    case kDown|k_Repeat:
+    case kDown:
+    case kLeft|k_Repeat:
+    case kLeft:
+    case kRight|k_Repeat:
+    case kRight:
+                  DisplayMenu()->Scroll(NORMALKEY(Key) == kUp || NORMALKEY(Key) == kLeft, NORMALKEY(Key) == kLeft || NORMALKEY(Key) == kRight);
+                  cStatus::MsgOsdTextItem(NULL, NORMALKEY(Key) == kUp);
+                  return osContinue;
+    default: break;
+    }
+
+  eOSState state = cOsdMenu::ProcessKey(Key);
+
+  if (state == osUnknown) {
+     switch (Key) {
+       case kRed:    Key = kOk; // will play the recording, even if recording commands are defined
+       case kGreen:  cRemote::Put(Key, true);
+                     // continue with osBack to close the info menu and process the key
+       case kOk:     return osBack;
+       default: break;
+       }
+     }
+  return state;
+}
+
 // --- cMenuRecordingItem ----------------------------------------------------
 
 class cMenuRecordingItem : public cOsdItem {
@@ -1530,7 +1590,7 @@
      else {
         NewHelpKeys = 2;
         cRecording *recording = GetRecording(ri);
-        if (recording && recording->Summary())
+        if (recording && recording->Info()->Title())
            NewHelpKeys = 3;
         }
      }
@@ -1539,7 +1599,7 @@
        case 0: SetHelp(NULL); break;
        case 1: SetHelp(tr("Open")); break;
        case 2:
-       case 3: SetHelp(RecordingCommands.Count() ? tr("Commands") : tr("Play"), tr("Rewind"), tr("Delete"), NewHelpKeys == 3 ? tr("Summary") : NULL);
+       case 3: SetHelp(RecordingCommands.Count() ? tr("Commands") : tr("Play"), tr("Rewind"), tr("Delete"), NewHelpKeys == 3 ? tr("Info") : NULL);
        }
      helpKeys = NewHelpKeys;
      }
@@ -1644,15 +1704,15 @@
   return osContinue;
 }
 
-eOSState cMenuRecordings::Summary(void)
+eOSState cMenuRecordings::Info(void)
 {
   if (HasSubMenu() || Count() == 0)
      return osContinue;
   cMenuRecordingItem *ri = (cMenuRecordingItem *)Get(Current());
   if (ri && !ri->IsDirectory()) {
      cRecording *recording = GetRecording(ri);
-     if (recording && recording->Summary() && *recording->Summary())
-        return AddSubMenu(new cMenuText(tr("Summary"), recording->Summary()));
+     if (recording && recording->Info()->Title())
+        return AddSubMenu(new cMenuRecording(recording));
      }
   return osContinue;
 }
@@ -1689,7 +1749,7 @@
        case kRed:    return (helpKeys > 1 && RecordingCommands.Count()) ? Commands() : Play();
        case kGreen:  return Rewind();
        case kYellow: return Delete();
-       case kBlue:   return Summary();
+       case kBlue:   return Info();
        case k1...k9: return Commands(Key);
        default: break;
        }
@@ -2568,36 +2628,43 @@
 
 // --- SetTrackDescriptions --------------------------------------------------
 
-static void SetTrackDescriptions(void)
+static void SetTrackDescriptions(bool Live)
 {
   cDevice::PrimaryDevice()->ClrAvailableTracks(true);
-  cChannel *Channel = Channels.GetByNumber(cDevice::CurrentChannel());
-  if (Channel) {
-     cSchedulesLock SchedulesLock;
-     const cSchedules *Schedules = cSchedules::Schedules(SchedulesLock);
-     if (Schedules) {
-        const cSchedule *Schedule = Schedules->GetSchedule(Channel->GetChannelID());
-        if (Schedule) {
-           const cEvent *Present = Schedule->GetPresentEvent(true);
-           if (Present) {
-              const cComponents *Components = Present->Components();
-              if (Components) {
-                 int indexAudio = 0;
-                 int indexDolby = 0;
-                 for (int i = 0; i < Components->NumComponents(); i++) {
-                     const tComponent *p = Components->Component(i);
-                     if (p->stream == 2) {
-                        if (p->type == 0x05)
-                           cDevice::PrimaryDevice()->SetAvailableTrack(ttDolby, indexDolby++, 0, NULL, p->description);
-                        else
-                           cDevice::PrimaryDevice()->SetAvailableTrack(ttAudio, indexAudio++, 0, NULL, p->description);
-                        }
-                     }
-                 }
+  const cComponents *Components = NULL;
+  cSchedulesLock SchedulesLock;
+  if (Live) {
+     cChannel *Channel = Channels.GetByNumber(cDevice::CurrentChannel());
+     if (Channel) {
+        const cSchedules *Schedules = cSchedules::Schedules(SchedulesLock);
+        if (Schedules) {
+           const cSchedule *Schedule = Schedules->GetSchedule(Channel->GetChannelID());
+           if (Schedule) {
+              const cEvent *Present = Schedule->GetPresentEvent(true);
+              if (Present)
+                 Components = Present->Components();
               }
            }
         }
      }
+  else if (cReplayControl::LastReplayed()) {
+     cRecording *Recording = Recordings.GetByName(cReplayControl::LastReplayed());
+     if (Recording)
+        Components = Recording->Info()->Components();
+     }
+  if (Components) {
+     int indexAudio = 0;
+     int indexDolby = 0;
+     for (int i = 0; i < Components->NumComponents(); i++) {
+         const tComponent *p = Components->Component(i);
+         if (p->stream == 2) {
+            if (p->type == 0x05)
+               cDevice::PrimaryDevice()->SetAvailableTrack(ttDolby, indexDolby++, 0, NULL, p->description);
+            else
+               cDevice::PrimaryDevice()->SetAvailableTrack(ttAudio, indexAudio++, 0, NULL, p->description);
+            }
+         }
+     }
 }
 
 // --- cDisplayChannel -------------------------------------------------------
@@ -2657,7 +2724,7 @@
            const cEvent *Present = Schedule->GetPresentEvent(true);
            const cEvent *Following = Schedule->GetFollowingEvent(true);
            if (Present != lastPresent || Following != lastFollowing) {
-              SetTrackDescriptions();
+              SetTrackDescriptions(true);
               displayChannel->SetEvents(Present, Following);
               cStatus::MsgOsdProgramme(Present ? Present->StartTime() : 0, Present ? Present->Title() : NULL, Present ? Present->ShortText() : NULL, Following ? Following->StartTime() : 0, Following ? Following->Title() : NULL, Following ? Following->ShortText() : NULL);
               lastPresent = Present;
@@ -2877,9 +2944,7 @@
 :cOsdObject(true)
 {
   cDevice::PrimaryDevice()->EnsureAudioTrack();
-  // Get the actual audio track descriptions from the EPG if we're not replaying:
-  if (!cDevice::PrimaryDevice()->Replaying() || cTransferControl::ReceiverDevice())
-     SetTrackDescriptions();
+  SetTrackDescriptions(!cDevice::PrimaryDevice()->Replaying() || cTransferControl::ReceiverDevice());
   currentDisplayTracks = this;
   numTracks = track = 0;
   audioChannel = cDevice::PrimaryDevice()->GetAudioChannel();
@@ -2994,6 +3059,11 @@
 
 cRecordControl::cRecordControl(cDevice *Device, cTimer *Timer, bool Pause)
 {
+  // We're going to manipulate an event here, so we need to prevent
+  // others from modifying any EPG data:
+  cSchedulesLock SchedulesLock;
+  cSchedules::Schedules(SchedulesLock);
+
   event = NULL;
   instantId = NULL;
   fileName = NULL;
@@ -3011,16 +3081,9 @@
   timer->SetRecording(true);
   event = timer->Event();
 
-  const char *Title = NULL;
-  const char *Subtitle = NULL;
-  const char *Summary = NULL;
-  if (event || GetEvent()) {
-     Title = event->Title();
-     Subtitle = event->ShortText();
-     Summary = event->Description();
-     dsyslog("Title: '%s' Subtitle: '%s'", Title, Subtitle);
-     }
-  cRecording Recording(timer, Title, Subtitle, Summary);
+  if (event || GetEvent())
+     dsyslog("Title: '%s' Subtitle: '%s'", event->Title(), event->ShortText());
+  cRecording Recording(timer, event);
   fileName = strdup(Recording.FileName());
 
   // crude attempt to avoid duplicate recordings:
@@ -3047,7 +3110,7 @@
      const cChannel *ch = timer->Channel();
      recorder = new cRecorder(fileName, ch->Ca(), timer->Priority(), ch->Vpid(), ch->Apids(), ch->Dpids(), ch->Spids());
      if (device->AttachReceiver(recorder)) {
-        Recording.WriteSummary();
+        Recording.WriteInfo();
         cStatus::MsgRecording(device, Recording.Name());
         if (!Timer && !cReplayControl::LastReplayed()) // an instant recording, maybe from cRecordControls::PauseLiveVideo()
            cReplayControl::SetRecording(fileName, Recording.Name());
diff -ruN vdr-1.3.24/menu.h vdr-1.3.25/menu.h
--- vdr-1.3.24/menu.h	2005-03-20 11:57:29.000000000 +0100
+++ vdr-1.3.25/menu.h	2005-05-15 16:34:54.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.h 1.69 2005/03/20 10:57:29 kls Exp $
+ * $Id: menu.h 1.70 2005/05/15 14:34:54 kls Exp $
  */
 
 #ifndef __MENU_H
@@ -133,7 +133,7 @@
   eOSState Play(void);
   eOSState Rewind(void);
   eOSState Delete(void);
-  eOSState Summary(void);
+  eOSState Info(void);
   eOSState Commands(eKeys Key = kNone);
 public:
   cMenuRecordings(const char *Base = NULL, int Level = 0, bool OpenSubMenus = false);
diff -ruN vdr-1.3.24/osd.c vdr-1.3.25/osd.c
--- vdr-1.3.24/osd.c	2004-12-19 13:27:38.000000000 +0100
+++ vdr-1.3.25/osd.c	2005-05-14 13:16:30.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osd.c 1.59 2004/12/19 12:27:38 kls Exp $
+ * $Id: osd.c 1.60 2005/05/14 11:16:30 kls Exp $
  */
 
 #include "osd.h"
@@ -574,7 +574,7 @@
 
 // --- cOsd ------------------------------------------------------------------
 
-bool cOsd::isOpen = false;
+int cOsd::isOpen = 0;
 
 cOsd::cOsd(int Left, int Top)
 {
@@ -585,7 +585,7 @@
   left = Left;
   top = Top;
   width = height = 0;
-  isOpen = true;
+  isOpen++;
 }
 
 cOsd::~cOsd()
@@ -593,7 +593,7 @@
   for (int i = 0; i < numBitmaps; i++)
       delete bitmaps[i];
   delete savedRegion;
-  isOpen = false;
+  isOpen--;
 }
 
 cBitmap *cOsd::GetBitmap(int Area)
diff -ruN vdr-1.3.24/osd.h vdr-1.3.25/osd.h
--- vdr-1.3.24/osd.h	2004-10-16 12:33:44.000000000 +0200
+++ vdr-1.3.25/osd.h	2005-05-14 13:15:55.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osd.h 1.47 2004/10/16 10:33:44 kls Exp $
+ * $Id: osd.h 1.48 2005/05/14 11:15:55 kls Exp $
  */
 
 #ifndef __OSD_H
@@ -210,7 +210,7 @@
 class cOsd {
   friend class cOsdProvider;
 private:
-  static bool isOpen;
+  static int isOpen;
   cBitmap *savedRegion;
   cBitmap *bitmaps[MAXOSDAREAS];
   int numBitmaps;
@@ -235,7 +235,7 @@
 public:
   virtual ~cOsd();
        ///< Shuts down the OSD.
-  static bool IsOpen(void) { return isOpen; }
+  static int IsOpen(void) { return isOpen; }
   int Left(void) { return left; }
   int Top(void) { return top; }
   int Width(void) { return width; }
diff -ruN vdr-1.3.24/player.h vdr-1.3.25/player.h
--- vdr-1.3.24/player.h	2005-02-12 15:45:29.000000000 +0100
+++ vdr-1.3.25/player.h	2005-05-22 13:07:42.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: player.h 1.16 2005/02/12 14:45:29 kls Exp $
+ * $Id: player.h 1.17 2005/05/22 11:07:42 kls Exp $
  */
 
 #ifndef __PLAYER_H
@@ -29,6 +29,7 @@
   void DevicePlay(void) { if (device) device->Play(); }
   void DeviceFreeze(void) { if (device) device->Freeze(); }
   void DeviceMute(void) { if (device) device->Mute(); }
+  void DeviceSetVideoDisplayFormat(eVideoDisplayFormat VideoDisplayFormat) { if (device) device->SetVideoDisplayFormat(VideoDisplayFormat); }
   void DeviceStillPicture(const uchar *Data, int Length) { if (device) device->StillPicture(Data, Length); }
   void Detach(void);
   virtual void Activate(bool On) {}
diff -ruN vdr-1.3.24/recording.c vdr-1.3.25/recording.c
--- vdr-1.3.24/recording.c	2005-05-07 17:25:15.000000000 +0200
+++ vdr-1.3.25/recording.c	2005-05-29 13:16:57.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.c 1.98 2005/05/07 15:25:15 kls Exp $
+ * $Id: recording.c 1.107 2005/05/29 11:16:57 kls Exp $
  */
 
 #include "recording.h"
@@ -23,6 +23,8 @@
 #include "tools.h"
 #include "videodir.h"
 
+#define SUMMARYFALLBACK
+
 #define RECEXT       ".rec"
 #define DELEXT       ".del"
 /* This was the original code, which works fine in a Linux only environment.
@@ -45,7 +47,10 @@
 // end of implementation for brain dead systems
 
 #define RESUMEFILESUFFIX  "/resume%s%s.vdr"
+#ifdef SUMMARYFALLBACK
 #define SUMMARYFILESUFFIX "/summary.vdr"
+#endif
+#define INFOFILESUFFIX    "/info.vdr"
 #define MARKSFILESUFFIX   "/marks.vdr"
 
 #define MINDISKSPACE 1024 // MB
@@ -213,6 +218,68 @@
      }
 }
 
+// --- cRecordingInfo --------------------------------------------------------
+
+cRecordingInfo::cRecordingInfo(const cEvent *Event)
+{
+  if (Event) {
+     event = Event;
+     channelID = event->ChannelID();
+     ownEvent = NULL;
+     }
+  else
+     event = ownEvent = new cEvent(0);
+}
+
+cRecordingInfo::~cRecordingInfo()
+{
+  delete ownEvent;
+}
+
+void cRecordingInfo::SetData(const char *Title, const char *ShortText, const char *Description)
+{
+  if (!isempty(Title))
+     ((cEvent *)event)->SetTitle(Title);
+  if (!isempty(ShortText))
+     ((cEvent *)event)->SetShortText(ShortText);
+  if (!isempty(Description))
+     ((cEvent *)event)->SetDescription(Description);
+}
+
+bool cRecordingInfo::Read(FILE *f)
+{
+  if (ownEvent) {
+     cReadLine ReadLine;
+     char *s;
+     while ((s = ReadLine.Read(f)) != NULL) {
+           char *t = skipspace(s + 1);
+           switch (*s) {
+             case 'C': {
+                         char *p = strchr(t, ' ');
+                         if (p)
+                            *p = 0; // strips optional channel name
+                         if (*t)
+                            channelID = tChannelID::FromString(t);
+                       }
+                       break;
+             default: if (!ownEvent->Parse(s))
+                         return false;
+                      break;
+             }
+           }
+     return true;
+     }
+  return false;
+}
+
+bool cRecordingInfo::Write(FILE *f, const char *Prefix) const
+{
+  if (channelID.Valid())
+     fprintf(f, "%sC %s\n", Prefix, *channelID.ToString());
+  event->Dump(f, Prefix, true);
+  return true;
+}
+
 // --- cRecording ------------------------------------------------------------
 
 #define RESUME_NOT_INITIALIZED (-2)
@@ -308,7 +375,7 @@
   return s;
 }
 
-cRecording::cRecording(cTimer *Timer, const char *Title, const char *Subtitle, const char *Summary)
+cRecording::cRecording(cTimer *Timer, const cEvent *Event)
 {
   resume = RESUME_NOT_INITIALIZED;
   titleBuffer = NULL;
@@ -316,7 +383,8 @@
   fileName = NULL;
   name = NULL;
   // set up the actual name:
-  const char *OriginalSubtitle = Subtitle;
+  const char *Title = Event ? Event->Title() : NULL;
+  const char *Subtitle = Event ? Event->ShortText() : NULL;
   char SubtitleBuffer[MAX_SUBTITLE_LENGTH];
   if (isempty(Title))
      Title = Timer->Channel()->Name();
@@ -333,6 +401,14 @@
      name = strdup(Timer->File());
      name = strreplace(name, TIMERMACRO_TITLE, Title);
      name = strreplace(name, TIMERMACRO_EPISODE, Subtitle);
+     // avoid blanks at the end:
+     int l = strlen(name);
+     while (l-- > 2) {
+           if (name[l] == ' ' && name[l - 1] != '~')
+              name[l] = 0;
+           else
+              break;
+           }
      if (Timer->IsSingleEvent()) {
         Timer->SetFile(name); // this was an instant recording, so let's set the actual data
         Timers.SetModified();
@@ -347,17 +423,13 @@
   start = Timer->StartTime();
   priority = Timer->Priority();
   lifetime = Timer->Lifetime();
-  // handle summary:
-  summary = !isempty(Timer->Summary()) ? strdup(Timer->Summary()) : NULL;
-  if (!summary) {
-     Subtitle = OriginalSubtitle;
-     if (isempty(Subtitle))
-        Subtitle = "";
-     if (isempty(Summary))
-        Summary = "";
-     if (*Subtitle || *Summary)
-        asprintf(&summary, "%s\n\n%s%s%s", Title, Subtitle, (*Subtitle && *Summary) ? "\n\n" : "", Summary);
-     }
+  // handle info:
+  info = new cRecordingInfo(Event);
+  // this is a somewhat ugly hack to get the 'summary' information from the
+  // timer into the recording info, but it saves us from having to actually
+  // copy the entire event data:
+  if (!isempty(Timer->Summary()))
+     info->SetData(isempty(info->Title()) ? Timer->File() : NULL, NULL, Timer->Summary());
 }
 
 cRecording::cRecording(const char *FileName)
@@ -370,7 +442,7 @@
   char *p = strrchr(FileName, '/');
 
   name = NULL;
-  summary = NULL;
+  info = new cRecordingInfo;
   if (p) {
      time_t now = time(NULL);
      struct tm tm_r;
@@ -386,39 +458,57 @@
         name[p - FileName] = 0;
         name = ExchangeChars(name, false);
         }
-     // read an optional summary file:
-     char *SummaryFileName = NULL;
-     asprintf(&SummaryFileName, "%s%s", fileName, SUMMARYFILESUFFIX);
-     int f = open(SummaryFileName, O_RDONLY);
-     if (f >= 0) {
-        struct stat buf;
-        if (fstat(f, &buf) == 0) {
-           int size = buf.st_size;
-           summary = MALLOC(char, size + 1); // +1 for terminating 0
-           if (summary) {
-              int rbytes = safe_read(f, summary, size);
-              if (rbytes >= 0) {
-                 summary[rbytes] = 0;
-                 if (rbytes != size)
-                    esyslog("%s: expected %d bytes but read %d", SummaryFileName, size, rbytes);
-                 }
-              else {
-                 LOG_ERROR_STR(SummaryFileName);
-                 free(summary);
-                 summary = NULL;
+     // read an optional info file:
+     char *InfoFileName = NULL;
+     asprintf(&InfoFileName, "%s%s", fileName, INFOFILESUFFIX);
+     FILE *f = fopen(InfoFileName, "r");
+     if (f) {
+        info->Read(f);
+        fclose(f);
+        }
+     else if (errno != ENOENT)
+        LOG_ERROR_STR(InfoFileName);
+     free(InfoFileName);
+#ifdef SUMMARYFALLBACK
+     // fall back to the old 'summary.vdr' if there was no 'info.vdr':
+     if (isempty(info->Title())) {
+        char *SummaryFileName = NULL;
+        asprintf(&SummaryFileName, "%s%s", fileName, SUMMARYFILESUFFIX);
+        FILE *f = fopen(SummaryFileName, "r");
+        if (f) {
+           int line = 0;
+           char *data[3] = { NULL };
+           cReadLine ReadLine;
+           char *s;
+           while ((s = ReadLine.Read(f)) != NULL && line < 3) {
+                 if (*s) {
+                    if (data[line]) {
+                       int len = strlen(s);
+                       len += strlen(data[line]) + 1;
+                       data[line] = (char *)realloc(data[line], len + 1);
+                       strcat(data[line], "\n");
+                       strcat(data[line], s);
+                       }
+                    else
+                       data[line] = strdup(s);
+                    }
+                 else
+                    line++;
                  }
-
+           fclose(f);
+           if (line == 1) {
+              data[2] = data[1];
+              data[1] = NULL;
               }
-           else
-              esyslog("can't allocate %d byte of memory for summary file '%s'", size + 1, SummaryFileName);
-           close(f);
+           info->SetData(data[0], data[1], data[2]);
+           for (int i = 0; i < 3; i ++)
+               free(data[i]);
            }
-        else
+        else if (errno != ENOENT)
            LOG_ERROR_STR(SummaryFileName);
+        free(SummaryFileName);
         }
-     else if (errno != ENOENT)
-        LOG_ERROR_STR(SummaryFileName);
-     free(SummaryFileName);
+#endif
      }
 }
 
@@ -428,7 +518,7 @@
   free(sortBuffer);
   free(fileName);
   free(name);
-  free(summary);
+  delete info;
 }
 
 char *cRecording::StripEpisodeName(char *s)
@@ -513,7 +603,8 @@
                             Delimiter,
                             s);
      // let's not display a trailing '~':
-     stripspace(titleBuffer);
+     if (!NewIndicator)
+        stripspace(titleBuffer);
      s = &titleBuffer[strlen(titleBuffer) - 1];
      if (*s == '~')
         *s = 0;
@@ -568,21 +659,18 @@
   return *s == '%';
 }
 
-bool cRecording::WriteSummary(void)
+bool cRecording::WriteInfo(void)
 {
-  if (summary) {
-     char *SummaryFileName = NULL;
-     asprintf(&SummaryFileName, "%s%s", fileName, SUMMARYFILESUFFIX);
-     FILE *f = fopen(SummaryFileName, "w");
-     if (f) {
-        if (fputs(summary, f) < 0)
-           LOG_ERROR_STR(SummaryFileName);
-        fclose(f);
-        }
-     else
-        LOG_ERROR_STR(SummaryFileName);
-     free(SummaryFileName);
+  char *InfoFileName = NULL;
+  asprintf(&InfoFileName, "%s%s", fileName, INFOFILESUFFIX);
+  FILE *f = fopen(InfoFileName, "w");
+  if (f) {
+     info->Write(f);
+     fclose(f);
      }
+  else
+     LOG_ERROR_STR(InfoFileName);
+  free(InfoFileName);
   return true;
 }
 
@@ -956,7 +1044,7 @@
             LOG_ERROR_STR(fileName);
          if (Index < last - (i ? 2 * INDEXSAFETYLIMIT : 0) || Index > 10 * INDEXSAFETYLIMIT) // keep off the end in case of "Pause live video"
             break;
-         sleep(1);
+         cCondWait::SleepMs(1000);
          }
      }
   return index != NULL;
diff -ruN vdr-1.3.24/recording.h vdr-1.3.25/recording.h
--- vdr-1.3.24/recording.h	2005-01-16 16:11:31.000000000 +0100
+++ vdr-1.3.25/recording.h	2005-05-28 11:34:07.000000000 +0200
@@ -4,14 +4,16 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.h 1.34 2005/01/16 15:11:31 kls Exp $
+ * $Id: recording.h 1.38 2005/05/28 09:34:07 kls Exp $
  */
 
 #ifndef __RECORDING_H
 #define __RECORDING_H
 
 #include <time.h>
+#include "channels.h"
 #include "config.h"
+#include "epg.h"
 #include "thread.h"
 #include "timers.h"
 #include "tools.h"
@@ -32,6 +34,24 @@
   void Delete(void);
   };
 
+class cRecordingInfo {
+  friend class cRecording;
+private:
+  tChannelID channelID;
+  const cEvent *event;
+  cEvent *ownEvent;
+  cRecordingInfo(const cEvent *Event = NULL);
+  void SetData(const char *Title, const char *ShortText, const char *Description);
+public:
+  ~cRecordingInfo();
+  const char *Title(void) const { return event->Title(); }
+  const char *ShortText(void) const { return event->ShortText(); }
+  const char *Description(void) const { return event->Description(); }
+  const cComponents *Components(void) const { return event->Components(); }
+  bool Read(FILE *f);
+  bool Write(FILE *f, const char *Prefix = "") const;
+  };
+
 class cRecording : public cListObject {
 private:
   mutable int resume;
@@ -39,7 +59,7 @@
   mutable char *sortBuffer;
   mutable char *fileName;
   mutable char *name;
-  char *summary;
+  cRecordingInfo *info;
   static char *StripEpisodeName(char *s);
   char *SortName(void) const;
   int GetResume(void) const;
@@ -47,19 +67,19 @@
   time_t start;
   int priority;
   int lifetime;
-  cRecording(cTimer *Timer, const char *Title, const char *Subtitle, const char *Summary);
+  cRecording(cTimer *Timer, const cEvent *Event);
   cRecording(const char *FileName);
   ~cRecording();
   virtual int Compare(const cListObject &ListObject) const;
   const char *Name(void) const { return name; }
   const char *FileName(void) const;
   const char *Title(char Delimiter = ' ', bool NewIndicator = false, int Level = -1) const;
-  const char *Summary(void) const { return summary; }
+  const cRecordingInfo *Info(void) const { return info; }
   const char *PrefixFileName(char Prefix);
   int HierarchyLevels(void) const;
   bool IsNew(void) const { return GetResume() <= 0; }
   bool IsEdited(void) const;
-  bool WriteSummary(void);
+  bool WriteInfo(void);
   bool Delete(void);
        // Changes the file name so that it will no longer be visible in the "Recordings" menu
        // Returns false in case of error
diff -ruN vdr-1.3.24/sdt.c vdr-1.3.25/sdt.c
--- vdr-1.3.24/sdt.c	2004-10-31 13:10:20.000000000 +0100
+++ vdr-1.3.25/sdt.c	2005-05-14 11:39:46.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: sdt.c 1.13 2004/10/31 12:10:20 kls Exp $
+ * $Id: sdt.c 1.14 2005/05/14 09:39:46 kls Exp $
  */
 
 #include "sdt.h"
@@ -62,6 +62,15 @@
                         sd->serviceName.getText(NameBuf, ShortNameBuf, sizeof(NameBuf), sizeof(ShortNameBuf));
                         char *pn = compactspace(NameBuf);
                         char *ps = compactspace(ShortNameBuf);
+                        if (!*ps && cSource::IsCable(Source())) {
+                           // Some cable providers don't mark short channel names according to the
+                           // standard, but rather go their own way and use "name>short name":
+                           char *p = strchr(pn, '>');
+                           if (p && p > pn) {
+                              *p++ = 0;
+                              strcpy(ShortNameBuf, p);
+                              }
+                           }
                         sd->providerName.getText(ProviderNameBuf, sizeof(ProviderNameBuf));
                         char *pp = compactspace(ProviderNameBuf);
                         if (channel) {
diff -ruN vdr-1.3.24/sections.c vdr-1.3.25/sections.c
--- vdr-1.3.24/sections.c	2004-10-24 13:05:12.000000000 +0200
+++ vdr-1.3.25/sections.c	2005-05-29 13:43:17.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: sections.c 1.10 2004/10/24 11:05:12 kls Exp $
+ * $Id: sections.c 1.11 2005/05/29 11:43:17 kls Exp $
  */
 
 #include "sections.h"
@@ -167,6 +167,7 @@
 void cSectionHandler::Action(void)
 {
   active = true;
+  SetPriority(19);
   while (active) {
 
         Lock();
diff -ruN vdr-1.3.24/skinclassic.c vdr-1.3.25/skinclassic.c
--- vdr-1.3.24/skinclassic.c	2005-01-09 12:56:29.000000000 +0100
+++ vdr-1.3.25/skinclassic.c	2005-05-16 12:45:07.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skinclassic.c 1.11 2005/01/09 11:56:29 kls Exp $
+ * $Id: skinclassic.c 1.12 2005/05/16 10:45:07 kls Exp $
  */
 
 #include "skinclassic.h"
@@ -326,7 +326,33 @@
 
 void cSkinClassicDisplayMenu::SetRecording(const cRecording *Recording)
 {
-  SetText(Recording->Summary(), false); //TODO
+  if (!Recording)
+     return;
+  const cRecordingInfo *Info = Recording->Info();
+  const cFont *font = cFont::GetFont(fontOsd);
+  int xl = x0 + 10;
+  int y = y2;
+  cTextScroller ts;
+  char t[32];
+  snprintf(t, sizeof(t), "%s  %s", *DateString(Recording->start), *TimeString(Recording->start));
+  ts.Set(osd, xl, y, x1 - xl, y3 - y, t, font, Theme.Color(clrMenuEventTime), Theme.Color(clrBackground));
+  y += ts.Height();
+  y += font->Height();
+  const char *Title = Info->Title();
+  if (isempty(Title))
+     Title = Recording->Name();
+  ts.Set(osd, xl, y, x1 - xl, y3 - y, Title, font, Theme.Color(clrMenuEventTitle), Theme.Color(clrBackground));
+  y += ts.Height();
+  if (!isempty(Info->ShortText())) {
+     const cFont *font = cFont::GetFont(fontSml);
+     ts.Set(osd, xl, y, x1 - xl, y3 - y, Info->ShortText(), font, Theme.Color(clrMenuEventShortText), Theme.Color(clrBackground));
+     y += ts.Height();
+     }
+  y += font->Height();
+  if (!isempty(Info->Description())) {
+     textScroller.Set(osd, xl, y, x1 - xl - 2 * ScrollWidth, y3 - y, Info->Description(), font, Theme.Color(clrMenuEventDescription), Theme.Color(clrBackground));
+     SetScrollbar();
+     }
 }
 
 void cSkinClassicDisplayMenu::SetText(const char *Text, bool FixedFont)
diff -ruN vdr-1.3.24/skins.h vdr-1.3.25/skins.h
--- vdr-1.3.24/skins.h	2005-02-27 15:37:37.000000000 +0100
+++ vdr-1.3.25/skins.h	2005-05-15 16:41:41.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skins.h 1.7 2005/02/27 14:37:37 kls Exp $
+ * $Id: skins.h 1.8 2005/05/15 14:41:41 kls Exp $
  */
 
 #ifndef __SKINS_H
@@ -150,7 +150,7 @@
        ///< that text if necessary.
   virtual void SetRecording(const cRecording *Recording) = 0;
        ///< Sets the Recording that shall be displayed, using the entire central area
-       ///< of the menu. The Recording's 'summary' shall be displayed using a
+       ///< of the menu. The Recording's 'description' shall be displayed using a
        ///< cTextScroller, and the Scroll() function will be called to drive scrolling
        ///< that text if necessary.
   virtual void SetText(const char *Text, bool FixedFont) = 0;
